Attribute VB_Name = "DL"
Option Explicit

Public Sub CreateDL()
'Created by Helen Feddema 12-Aug-2007
'Last modified 12-Aug-2007

On Error GoTo ErrorHandler
   
   Dim appExcel As New Excel.Application
   Dim con As Outlook.ContactItem
   Dim DL As Outlook.DistListItem
   Dim fil As Scripting.File
   Dim fldContacts As Outlook.MAPIFolder
   Dim fso As New Scripting.FileSystemObject
   Dim lngCurrentRow As Long
   Dim lngRows As Long
   Dim nms As Outlook.NameSpace
   Dim rcp As Outlook.Recipient
   Dim rngEMail As Excel.range
   Dim rngName As Excel.range
   Dim strDLName As String
   Dim strEMail As String
   Dim strName As String
   Dim strPath As String
   Dim strPrompt As String
   Dim strRange As String
   Dim strTitle As String
   Dim strWorkbook As String
   Dim strWorkbookPath As String
   Dim wkb As Excel.Workbook
   Dim wks As Excel.Worksheet
   
   Set nms = Application.GetNamespace("MAPI")
   
SelectFolder:
   Set fldContacts = nms.PickFolder
   If fldContacts.DefaultItemType <> olContactItem Then
      strTitle = "Wrong folder type"
      strPrompt = "Please select a Contacts folder"
      MsgBox prompt:=strPrompt, _
         Buttons:=vbExclamation + vbOKOnly, _
         Title:=strTitle
      GoTo SelectFolder
   End If
  'Debug.Print "Selected folder name: " & fldContacts.Name
      
   Set DL = Application.CreateItem(olDistributionListItem)
   
   'Get Distribution List name from InputBox
   strDLName = InputBox(prompt:="Distribution List name:", _
      Title:="DL name", _
      Default:="Excel contacts")
   If strDLName = "" Then
      GoTo ErrorHandlerExit
   End If
   
   DL.DLName = strDLName
   
   'Get worksheet name and path from inputbox
   '(FileDialog doesn't work from Outlook)
   strWorkbook = InputBox(prompt:="Workbook name and path:", _
      Title:="DL workbook", _
      Default:="K:\Documents\Web Site\Code Sample 61\Distribution List.xls")
   If strWorkbook = "" Then
      GoTo ErrorHandlerExit
   Else
      strWorkbookPath = Left(strWorkbook, Len(strWorkbook) - 21)
      
On Error Resume Next
      'Check that workbook is in the specified location
      Set fil = fso.GetFile(strWorkbook)
      If fil Is Nothing Then
         strPrompt = "Can't find Distribution List workbook " _
            & " in " & strWorkbookPath & "; canceling"
         MsgBox strPrompt, vbCritical + vbOKOnly
         GoTo ErrorHandlerExit
      End If
   
On Error GoTo ErrorHandler
   End If
   
   'Or can hard-code the name and path:
   'strWorkbook = "K:\Documents\Web Site\Code Sample 61\Distribution List.xls"
   
   'Open workbook and activate worksheet
   Set wkb = appExcel.Workbooks.Open(strWorkbook)
   Set wks = wkb.Sheets(1)
   wks.Activate
   appExcel.Visible = True
      
   'Get last data row number
   lngRows = wks.UsedRange.Rows.Count

   'Set up loop to process names and add to DL
   strRange = "A1"
   Set rngName = appExcel.range(strRange)
   rngName.Select
   
   Do While lngCurrentRow <= lngRows
      lngCurrentRow = rngName.Row
      'Debug.Print "On Row " & lngCurrentRow
      strName = ""
      strEMail = ""
      strName = rngName.Value
      If strName = "" Then
         GoTo NextRow
      End If
      Set rngEMail = appExcel.ActiveCell.Offset(columnoffset:=1)
      strEMail = rngEMail.Value
      'Debug.Print "Name: " & strName & "; Email: " & strEMail
      
On Error Resume Next
      'Attempt to set reference to contact, in case it
      'already exists
      Set con = fldContacts.Items(strName)
      
On Error GoTo ErrorHandler
      If con Is Nothing Then
         'Create Contact item for name
         Set con = fldContacts.Items.Add(olContactItem)
         con.FullName = strName
         con.FileAs = strName
         con.Email1Address = strEMail
         con.Close (olSave)
      End If
      
      Set con = Nothing
      Set rcp = Application.Session.CreateRecipient(strName)
      'Debug.Print "Trying to resolve " & strName
      rcp.Resolve
      If rcp.Resolved = True Then
         DL.AddMember rcp
      Else
         strTitle = "Problem with recipient"
         strPrompt = "Recipient " & strName & _
            " could not be resolved; skipping"
         MsgBox prompt:=strPrompt, _
            Buttons:=vbExclamation + vbOKOnly, _
            Title:=strTitle
         'Debug.Print strName & " could not be resolved"
      End If

NextRow:
      rngName.Select
      Set rngName = appExcel.ActiveCell.Offset(rowoffset:=1)
      rngName.Select
   Loop
   
   DL.Save
   DL.Display
   
ErrorHandlerExit:
   Set appExcel = Nothing
   Exit Sub

ErrorHandler:
   MsgBox "Error No: " & Err.Number & "; Description: " & _
      Err.Description
   Resume ErrorHandlerExit

End Sub
